

Math_Run_Start:	equ	$CDBA
;Math_Run_Start:	equ	$CD57

Gen_Random:		equ	$CE45
;Gen_Random:		equ	$CDE2


	include	"Direct_Page.asm"

	include	"Memory_Locations.asm"

; ===========================================================================

; Segment type:	Pure code
		; segment ROM
		org $6000
MATHROM:	fdb $7EF2
		fdb $61EF
		fcb $56	; V


	include	"Object_3D_Data.asm"




; =============== S U B	R O U T	I N E =======================================

sub_670D:
		ldx	#byte_496F
		lda	#0

loc_6712:
		sta	,x+
		cmpx	#byte_496F+$1A
		bcs	loc_6712
		lda	#$60 ; '`'
		lsra
		sta	<DPbyte_D2
		ldd	#$5300
		std	<DPbyte_D4
		rts
; End of function sub_670D


; =============== S U B	R O U T	I N E =======================================


sub_6724:
		stb	<DPbyte_DC	; Selected object model
		ldb	<DPbyte_DC	; Selected object model
		ldx	#byte_496F
		lda	b,x
		bne	locret_6760
		lda	<DPbyte_D2
		sta	b,x
		ldx	#Object_Size_Table ; Array of object sizes?
		lda	b,x
		sta	<DPbyte_1	; Number of points in object?
		lsra
		adda	<DPbyte_D2
		bcc	loc_6740
		swi

loc_6740:
		sta	<DPbyte_D2
		ldx	#Obj_List	; Table	of pointers to object X, Y, Z point data?
		aslb
		ldx	b,x
		ldu	<DPbyte_D4

loc_674A:
		ldd	,x
		std	,u
		ldd	2,x
		std	2,u
		ldd	4,x
		std	4,u
		leax	6,x
		leau	8,u
		dec	<DPbyte_1	; Loop count for object	points
		bgt	loc_674A	; Copy XYZ data	to math	RAM
		stu	<DPbyte_D4

locret_6760:
		rts
; End of function sub_6724


; =============== S U B	R O U T	I N E =======================================


sub_6761:
		ldd	MW0		; Called during	space, towers and trench
		std	MReg00		; Math result X
		lda	#$86 ; ''      ; Reg01 = Reg01 x Reg00
					; Reg02	= Reg02	x Reg00
		jsr	Math_Run_Start
		ldd	MReg02		; Math result Z
		std	<DPbyte_D8
		addd	#$FF98
		anda	#$1F
		std	,y++
		ldd	MReg01		; Math result Y
		std	<DPbyte_D6
		anda	#$1F
		std	,y++
		rts
; End of function sub_6761


; =============== S U B	R O U T	I N E =======================================


sub_6782:
		ldd	MW0		; Calc trench floor lines
		std	MReg00		; Math result X
		lda	#$86 ; ''      ; Reg01 = Reg01 x Reg00
					; Reg02	= Reg02	x Reg00
		jsr	Math_Run_Start
		ldd	MReg02		; Math result Z
		subd	<DPbyte_D8
		anda	#$1F
		std	,y++
		ldd	MReg02		; Math result Z
		std	<DPbyte_D8
		ldd	MReg01		; Math result Y
		subd	<DPbyte_D6
		ora	#$E0 ; ''
		std	,y++
		ldd	MReg01		; Math result Y
		std	<DPbyte_D6
		rts
; End of function sub_6782


; =============== S U B	R O U T	I N E =======================================


sub_67AA:
		ldd	MW0		; Calc trench vertical lines on	walls
		std	MReg00		; Math result X
		lda	#$86 ; ''      ; Reg01 = Reg01 x Reg00
					; Reg02	= Reg02	x Reg00
		jsr	Math_Run_Start
		ldd	MReg02		; Math result Z
		subd	<DPbyte_D8
		anda	#$1F
		std	,y++
		ldd	MReg02		; Math result Z
		std	<DPbyte_D8
		ldd	MReg01		; Math result Y
		subd	<DPbyte_D6
		anda	#$1F
		std	,y++
		ldd	MReg01		; Math result Y
		std	<DPbyte_D6
		rts
; End of function sub_67AA


; =============== S U B	R O U T	I N E =======================================


sub_67D2:
		stb	<DPbyte_DC	; Called during	space
; End of function sub_67D2


; =============== S U B	R O U T	I N E =======================================


sub_67D4:
		ldb	<DPbyte_DC	; Selected object model
		ldx	#Object_Size_Table
		lda	b,x
		sta	<DPbyte_1	; Loop count for object	points
		ldx	#byte_496F
		lda	b,x
		bne	loc_67E5
		swi

loc_67E5:
		asla
		sta	MW2		; Set BIC
		rola
		sta	MW1
		ldx	#Scratch_RAM_start

loc_67F0:				; Math program 0x50. Matrix Multiply - Transposed
		lda	#$50 ; 'P'
		jsr	Math_Run_Start
		ldd	MReg00		; Math result X
		std	DVSRH
		orcc	#0
		ldd	MW0
		std	MReg00		; Math result X
		lda	#$86 ; ''      ; Reg01 = Reg01 x Reg00
					; Reg02	= Reg02	x Reg00
		jsr	Math_Run_Start
		ldd	MReg01		; Math result Y
		std	,x
		ldd	MReg02		; Math result Z
		std	2,x
		leax	4,x
		dec	<DPbyte_1	; Loop until all object	points done
		bgt	loc_67F0
		rts
; End of function sub_67D4


; =============== S U B	R O U T	I N E =======================================

; Format vectors for ties, and tower/bunker explosions

sub_6819:
		ldx	#JumpTable7610Hi ; Called during space and towers
		ldb	<DPbyte_DC	; Selected object model
		aslb
		ldu	b,x
		ldb	,u+
		beq	loc_6826
		swi

loc_6826:
		ldb	,u+
		bitb	#2
		beq	loc_6838
		cmpb	#$FF
		beq	locret_6863
		lsrb
		lsrb
		cmpb	<DPbyte_DB
		bhi	loc_6826
		bra	locret_6863
; ---------------------------------------------------------------------------

loc_6838:
		clra
		bitb	#3
		bne	loc_683F
		lda	#$E0 ; ''      ; Vector is visible

loc_683F:
		sta	<DPbyte_DA
		andb	#$FC ; ''
		ldx	#Scratch_RAM_start
		abx
		ldd	2,x
		subd	<DPbyte_D8
		anda	#$1F
		std	,y++
		ldd	,x
		subd	<DPbyte_D6
		anda	#$1F
		ora	<DPbyte_DA
		std	,y++
		ldd	,x
		std	<DPbyte_D6
		ldd	2,x
		std	<DPbyte_D8
		bra	loc_6826
; ---------------------------------------------------------------------------

locret_6863:
		rts
; End of function sub_6819


; =============== S U B	R O U T	I N E =======================================


sub_6864:
		ldd	#0		; Left hand side of trench turret calculation
		std	Math_XT2	; XT2
		std	Math_YT2	; Clear	XT, YT and ZT to zero
		std	Math_ZT2	; ZT2
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		sta	<DPbyte_1	; Loop count for object	points
		ldx	#Obj_List
		aslb
		ldu	b,x
		ldx	#$5DF0

loc_6882:
		ldd	,u++
		std	word_5E00
		ldd	,u++
		std	word_5E02
		ldd	,u++
		std	word_5E04
		ldd	#$1C0		; Point	BIC to Math RAM	$5E00
		std	MW1
		lda	#$2A ; '*'
		jsr	Math_Run_Start
		ldd	MReg00		; Math result X
		std	6,x
		ldd	MReg01		; Math result Y
		std	$18,x
		ldd	MReg02		; Math result Z
		std	$1A,x
		leax	$10,x
		dec	<DPbyte_1	; Loop until all object	points done
		bgt	loc_6882
		ldd	MReg4C
		std	Math_XT2	; XT2
		ldd	MReg4D
		std	Math_YT2	; YT2
		ldd	MReg4E
		std	Math_ZT2	; ZT2
		rts
; End of function sub_6864


; =============== S U B	R O U T	I N E =======================================


sub_68C7:
		ldd	#0		; Right	hand side of trench turret calculation
		std	Math_XT2	; XT2
		std	Math_YT2	; Clear	XT, YT and ZT to zero
		std	Math_ZT2	; ZT2
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		sta	<DPbyte_1	; Loop count for object	points
		ldx	#Obj_List
		aslb
		ldu	b,x
		ldx	#$5DF0

loc_68E5:
		ldd	,u++
		std	word_5E00
		ldd	#0
		subd	,u++		; Negate
		std	word_5E02
		ldd	,u++
		std	word_5E04
		ldd	#$1C0		; Point	BIC to Math RAM	$5E00
		std	MW1
		lda	#$2A ; '*'
		jsr	Math_Run_Start
		ldd	MReg00		; Math result X
		std	6,x
		ldd	MReg01		; Math result Y
		std	$18,x
		ldd	MReg02		; Math result Z
		std	$1A,x
		leax	$10,x
		dec	<DPbyte_1	; Loop count for object	points
		bgt	loc_68E5
		ldd	MReg4C
		std	Math_XT2	; XT2
		ldd	MReg4D
		std	Math_YT2	; YT2
		ldd	MReg4E
		std	Math_ZT2	; ZT2
		rts
; End of function sub_68C7


; =============== S U B	R O U T	I N E =======================================


sub_692D:
		ldd	#0		; Trench calculation
		subd	MReg00		; Math result X
		std	MReg00		; Math result X
		ldd	#0
		subd	MReg01		; Math result Y
		std	MReg01		; Math result Y
		ldd	#0
		subd	MReg02		; Math result Z
		std	MReg02		; Math result Z
		ldd	#$1C0		; Point	BIC to Math RAM	$5E00
		std	MW1
		ldd	word_5DF6
		subd	MReg00		; Math result X
		std	DVSRH
		lda	#$B0 ; ''      ; XT = [BIC,3] - Reg00
					; BIC++
		sta	MW0
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		ldb	#$AE ; ''      ; [BIC,2] = ([BIC,0] - Reg01) x (YT)
					; [BIC,3] = ([BIC,1] - Reg02) x	(YT)
					; BIC++
					; XT = (BIC,3) - Reg00
					; BIC++

loc_6965:
		ldu	MW0
		ldx	MReg0C		; XT
		stu	MReg0D		; YT
		stb	MW0		; Run math program $AE
		stx	DVSRH
		deca
		bgt	loc_6965
		rts
; End of function sub_692D


; =============== S U B	R O U T	I N E =======================================


sub_6978:
		ldd	#0		; Some trench calculation
		subd	MReg00		; Math result X
		std	MReg00		; Math result X
		ldd	#0
		subd	MReg01		; Math result Y
		std	MReg01		; Math result Y
		ldd	#0
		subd	MReg02		; Math result Z
		std	MReg02		; Math result Z
		ldd	#$1C0		; Point	BIC to Math RAM	$5E00
		std	MW1
		ldd	word_5DF6
		subd	MReg00		; Math result X
		std	DVSRH
		lda	#$B0 ; ''      ; XT Reg0C = [BIC,3] - Reg00
		sta	MW0
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		ldb	#$AE ; ''      ; [BIC,2] = ([BIC,0] - Reg01) x (YT)
					; [BIC,3] = ([BIC,1] - Reg02) x	(YT)
					; BIC++
					; XT = [BIC,3] - Reg00
					; BIC++

loc_69B0:
		ldu	MW0
		cmpu	#$100
		bgt	loc_69BC
		ldu	#$7FFF

loc_69BC:				; XT
		ldx	MReg0C
		stu	MReg0D		; YT
		stb	MW0
		stx	DVSRH
		deca
		bgt	loc_69B0
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		ldu	#$5E0C

loc_69D5:
		ldx	,u
		cmpx	#$216
		ble	loc_69E3
		ldx	#$216
		stx	,u
		bra	loc_69ED
; ---------------------------------------------------------------------------

loc_69E3:
		cmpx	#$FDEA
		bge	loc_69ED
		ldx	#$FDEA
		stx	,u

loc_69ED:
		ldx	2,u
		cmpx	#$2D8
		ble	loc_69FB
		ldx	#$2D8
		stx	2,u
		bra	loc_6A05
; ---------------------------------------------------------------------------

loc_69FB:
		cmpx	#$FDEC
		bge	loc_6A05
		ldx	#$FDEC
		stx	2,u

loc_6A05:
		leau	$10,u
		deca
		bgt	loc_69D5
		rts
; End of function sub_6978


; =============== S U B	R O U T	I N E =======================================


sub_6A0C:
		ldd	#0
		subd	MReg00		; Math result X
		std	MReg00		; Math result X
		ldd	#0
		subd	MReg01		; Math result Y
		std	MReg01		; Math result Y
		ldd	#0
		subd	MReg02		; Math result Z
		std	MReg02		; Math result Z
		ldd	#$1C0		; Point	BIC to Math RAM	$5E00
		std	MW1
		ldd	word_5DF6
		subd	MReg00		; Math result X
		std	DVSRH
		lda	#$B0 ; ''      ; Reg0C = [BIC,3] - Reg00
		sta	MW0
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		ldb	#$AE ; ''      ; [BIC,2] = ([BIC,0] - Reg01) x YT
					; [BIC,3] = ([BIC,1] - Reg02) x	YT
					; BIC++
					; XT = [BIC,3] - Reg00
					; BIC++

loc_6A44:
		ldu	MW0
		cmpu	#$100
		bgt	loc_6A50
		ldu	#$7FFF

loc_6A50:				; XT
		ldx	MReg0C
		stu	MReg0D		; YT
		stb	MW0
		stx	DVSRH
		deca
		bgt	loc_6A44	; Loop until all object	points done
		ldx	#Object_Size_Table
		ldb	<DPbyte_DC	; Selected object model
		lda	b,x
		ldu	#$5E0C

loc_6A69:
		ldx	,u
		cmpx	#$3FE
		ble	loc_6A77
		ldx	#$3FE
		stx	,u
		bra	loc_6A81
; ---------------------------------------------------------------------------

loc_6A77:
		cmpx	#$FC02
		bge	loc_6A81
		ldx	#$FC02
		stx	,u

loc_6A81:
		ldx	2,u
		cmpx	#$4C0
		ble	loc_6A8F
		ldx	#$4C0
		stx	2,u
		bra	loc_6A99
; ---------------------------------------------------------------------------

loc_6A8F:
		cmpx	#$FC04
		bge	loc_6A99
		ldx	#$FC04
		stx	2,u

loc_6A99:
		leau	$10,u
		deca
		bgt	loc_6A69
		rts
; End of function sub_6A0C


; =============== S U B	R O U T	I N E =======================================


sub_6AA0:
		ldx	#JumpTable7610Hi
		ldb	<DPbyte_DC	; Get object selected
		aslb
		ldu	b,x
		ldb	,u+
		cmpb	#1		; Check	that start of function has illegal $01 instruction byte. Why??
		beq	loc_6AAF
		swi

loc_6AAF:
		jmp	,u
; End of function sub_6AA0

; ---------------------------------------------------------------------------
byte_6AB1:	fcb 0, 5, 8, $C, $10, $14, $18,	4
		fcb $1C, $20, $24, $28,	$2C, $30, $1C, $64
		fcb $68, $6C, $70, $74,	$64, $94, $98, $9C
		fcb $BC, $9D, $A0, $A4,	$C4, $A5, $A8, $AC
		fcb $B0, $94, $B4, $B8,	$BC, $C0, $C4, $C8
		fcb $CC, $D0, $B4, $7C,	$80, $84, $88, $8C
		fcb $90, $7C, $4C, $50,	$54, $58, $5C, $60
		fcb $4C, $34, $38, $3C,	$40, $44, $48, $34
		fcb $39, $50, $80, $B8,	$98, $68, $20, 8
		fcb $D,	$24, $6C, $A0, $C1, $84, $54, $3C
		fcb $41, $58, $88, $C8,	$A8, $70, $28, $10
		fcb $15, $2C, $74, $AC,	$CC, $8C, $5C, $44
		fcb $49, $60, $90, $D0,	$B0, $78, $30, $18
		fcb $FF
byte_6B1A:	fcb 0, $1D, $20, $24, $28, $2C,	$30, $1C
		fcb $34, $38, $3C, $40,	$44, $48, $34, $1D
		fcb 4, 8, $C, $10, $14,	$18, 4,	9
		fcb $20, $38, $3D, $24,	$C, $11, $28, $40
		fcb $45, $2C, $14, $19,	$30, $48, $FF
byte_6B41:	fcb 0, 5, 8, $C, $10, $14, 4, $34
		fcb $38, $3C, $5C, $3D,	$40, $44, $64, $45
		fcb $48, $4C, $50, $34,	$54, $58, $5C, $60
		fcb $64, $68, $6C, $70,	$54, $1C, $20, $24
		fcb $28, $2C, $30, $1C,	$21, $58, $38, 8
		fcb $D,	$40, $61, $24, $29, $68, $48, $10
		fcb $15, $4C, $6C, $2C,	$31, $70, $50, $18
		fcb $FF
byte_6B7A:	fcb 0, $21, 4, 8, $C, $20, $1C,	$10
		fcb $C,	$11, $14, $18, $1C, $31, $2C, $28
		fcb $24, $30, $70, $6D,	$2C, $29, $68, $65
		fcb $24, $95, $90, $8C,	$88, $A8, $AC, $B0
		fcb $B4, $94, $98, $B8,	$BC, $C0, $A4, $84
		fcb $A0, $9C, $98, $9D,	$90, $8D, $A0, $85
		fcb $88, $A9, $A4, $C1,	$AC, $B1, $BC, $B9
		fcb $B4, $7D, $5C, $58,	$54, $54, $60, $5C
		fcb $59, $78, $75, $54,	$61, $80, $4D, $48
		fcb $44, $40, $4C, $50,	$3C, $40, $3D, $38
		fcb $34, $50, $C5, $C8,	$CC, $D0, $D4, $D8
		fcb $DC, $E0, $C4, $D4,	$D9, $C8, $CD, $DC
		fcb $E1, $D0, $FF
byte_6BDD:	fcb 0
		fcb $FF
byte_6BDF:	fcb 0
		fcb $FF
byte_6BE1:	fcb 0, 5, 8, $C, 4, $10, $14, 8
		fcb $15, $18, $C, $19, $10, $FF
byte_6BEF:	fcb 0, 5, 8, $C, $10, 4, $14, $18
		fcb 8, $19, $1C, $C, $1D, $20, $10, $21
		fcb $14, $FF
byte_6C01:	fcb 0, 5, 8, $C, $10, 4, $14, $1C
		fcb 8, $D, $1C,	$18, $14, $19, $10, $FF
byte_6C11:	fcb 0, 5, 8, $C, 4, $10, 8, $D
		fcb $10, $FF
byte_6C1B:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_6C1C:
		lda	#$5E ; '^'      ; Draws bunkers before exploded
		tfr	a, dp		; Change zero page to Math RAM
		ldd	<$0E
		addd	#$FF98
		anda	#$1F
		std	,y		; Y points to vector RAM
		ldd	<$0C
		anda	#$1F
		std	2,y
		ldd	<$04
		std	4,y
		ldd	<$00
		std	6,y
		ldd	<$1E
		subd	<$0E
		anda	#$1F
		std	8,y
		ldd	<$1C
		subd	<$0C
		anda	#$1F
		std	$A,y
		ldd	<$2E
		subd	<$1E
		anda	#$1F
		std	$C,y
		ldd	<$2C
		subd	<$1C
		ora	#$E0 ; ''
		std	$E,y
		ldd	<$EE
		subd	<$2E
		anda	#$1F
		std	$10,y
		ldd	<$EC
		subd	<$2C
		ora	#$E0 ; ''
		std	$12,y
		ldd	<$DE
		subd	<$EE
		anda	#$1F
		std	$14,y
		ldd	<$DC		; Selected object model
		subd	<$EC
		ora	#$E0 ; ''
		std	$16,y
		ldd	<$1E
		subd	<$DE
		anda	#$1F
		std	$18,y
		ldd	<$1C
		subd	<$DC		; Selected object model
		ora	#$E0 ; ''
		std	$1A,y
		ldd	<$3E
		subd	<$1E
		anda	#$1F
		std	$1C,y
		ldd	<$3C
		subd	<$1C
		ora	#$E0 ; ''
		std	$1E,y
		ldd	<$FE
		subd	<$3E
		anda	#$1F
		std	$20,y
		ldd	<$FC
		subd	<$3C
		ora	#$E0 ; ''
		std	$22,y
		ldd	<$DE
		subd	<$FE
		anda	#$1F
		std	$24,y
		ldd	<$DC		; Selected object model
		subd	<$FC
		ora	#$E0 ; ''
		std	$26,y
		ldd	<$EE
		subd	<$DE
		anda	#$1F
		std	$28,y
		ldd	<$EC
		subd	<$DC		; Selected object model
		anda	#$1F
		std	$2A,y
		ldd	<$FE
		subd	<$EE
		anda	#$1F
		std	$2C,y
		ldd	<$FC
		subd	<$EC
		ora	#$E0 ; ''
		std	$2E,y
		ldd	#$7200		; Insert Vector	SCAL 2,00 instruction
		std	$30,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$32,y
		leay	$34,y		; Increment vector RAM pointer by 52 bytes for bunker vector data
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_6C1C

; ---------------------------------------------------------------------------
byte_6CFB:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_6CFC:
		lda	#$5E ; '^'      ; Draws towers before top exploded
		tfr	a, dp
		ldd	<$0E
		addd	#$FF98
		anda	#$1F
		std	,y
		ldd	<$0C
		anda	#$1F
		std	2,y
		ldd	<$04
		std	4,y
		ldd	<$02
		std	6,y
		ldd	<$1E
		subd	<$0E
		anda	#$1F
		std	8,y
		ldd	<$1C
		subd	<$0C
		anda	#$1F
		std	$A,y
		ldd	<$3E
		subd	<$1E
		anda	#$1F
		std	$C,y
		ldd	<$3C
		subd	<$1C
		ora	#$E0 ; ''
		std	$E,y
		ldd	<$FE
		subd	<$3E
		anda	#$1F
		std	$10,y
		ldd	<$FC
		subd	<$3C
		ora	#$E0 ; ''
		std	$12,y
		ldd	<$CE
		subd	<$FE
		anda	#$1F
		std	$14,y
		ldd	<$CC
		subd	<$FC
		ora	#$E0 ; ''
		std	$16,y
		ldd	<$9E
		subd	<$CE
		anda	#$1F
		std	$18,y
		ldd	<$9C
		subd	<$CC
		ora	#$E0 ; ''
		std	$1A,y
		ldd	<$00
		std	$1C,y
		ldd	<$6E
		subd	<$9E
		anda	#$1F
		std	$1E,y
		ldd	<$6C
		subd	<$9C
		ora	#$E0 ; ''
		std	$20,y
		ldd	<$4E
		subd	<$6E
		anda	#$1F
		std	$22,y
		ldd	<$4C
		subd	<$6C
		ora	#$E0 ; ''
		std	$24,y
		ldd	<$7E
		subd	<$4E
		anda	#$1F
		std	$26,y
		ldd	<$7C
		subd	<$4C
		ora	#$E0 ; ''
		std	$28,y
		ldd	<$02
		std	$2A,y
		ldd	<$AE
		subd	<$7E
		anda	#$1F
		std	$2C,y
		ldd	<$AC
		subd	<$7C
		ora	#$E0 ; ''
		std	$2E,y
		ldd	<$DE
		subd	<$AE
		anda	#$1F
		std	$30,y
		ldd	<$DC		; Selected object model
		subd	<$AC
		ora	#$E0 ; ''
		std	$32,y
		ldd	<$1E
		subd	<$DE
		anda	#$1F
		std	$34,y
		ldd	<$1C
		subd	<$DC		; Selected object model
		ora	#$E0 ; ''
		std	$36,y
		ldd	<$2E
		subd	<$1E
		anda	#$1F
		std	$38,y
		ldd	<$2C
		subd	<$1C
		ora	#$E0 ; ''
		std	$3A,y
		ldd	<$EE
		subd	<$2E
		anda	#$1F
		std	$3C,y
		ldd	<$EC
		subd	<$2C
		ora	#$E0 ; ''
		std	$3E,y
		ldd	<$BE
		subd	<$EE
		anda	#$1F
		std	$40,y
		ldd	<$BC
		subd	<$EC
		ora	#$E0 ; ''
		std	$42,y
		ldd	<$8E
		subd	<$BE
		anda	#$1F
		std	$44,y
		ldd	<$8C
		subd	<$BC
		ora	#$E0 ; ''
		std	$46,y
		ldd	<$00
		std	$48,y
		ldd	<$5E
		subd	<$8E
		anda	#$1F
		std	$4A,y
		ldd	<$5C
		subd	<$8C
		ora	#$E0 ; ''
		std	$4C,y
		ldd	<$4E
		subd	<$5E
		anda	#$1F
		std	$4E,y
		ldd	<$4C
		subd	<$5C
		ora	#$E0 ; ''
		std	$50,y
		ldd	<$7E
		subd	<$4E
		anda	#$1F
		std	$52,y
		ldd	<$7C
		subd	<$4C
		anda	#$1F
		std	$54,y
		ldd	<$9E
		subd	<$7E
		anda	#$1F
		std	$56,y
		ldd	<$9C
		subd	<$7C
		ora	#$E0 ; ''
		std	$58,y
		ldd	<$7E
		subd	<$9E
		anda	#$1F
		std	$5A,y
		ldd	<$7C
		subd	<$9C
		anda	#$1F
		std	$5C,y
		ldd	<$8E
		subd	<$7E
		anda	#$1F
		std	$5E,y
		ldd	<$8C
		subd	<$7C
		ora	#$E0 ; ''
		std	$60,y
		ldd	#$7200		; Vector SCAL 2,0 instruction
		std	$62,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$64,y
		leay	$66,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_6CFC

; ---------------------------------------------------------------------------
byte_6EB0:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_6EB1:
		lda	#$5E ; '^'      ; Draws tower after top exploded
		tfr	a, dp
		ldd	<$0E
		addd	#$FF98
		anda	#$1F
		std	,y
		ldd	<$0C
		anda	#$1F
		std	2,y
		ldd	<$04
		std	4,y
		ldd	<$02
		std	6,y
		ldd	<$1E
		subd	<$0E
		anda	#$1F
		std	8,y
		ldd	<$1C
		subd	<$0C
		anda	#$1F
		std	$A,y
		ldd	<$3E
		subd	<$1E
		anda	#$1F
		std	$C,y
		ldd	<$3C
		subd	<$1C
		ora	#$E0 ; ''
		std	$E,y
		ldd	<$FE
		subd	<$3E
		anda	#$1F
		std	$10,y
		ldd	<$FC
		subd	<$3C
		ora	#$E0 ; ''
		std	$12,y
		ldd	<$CE
		subd	<$FE
		anda	#$1F
		std	$14,y
		ldd	<$CC
		subd	<$FC
		ora	#$E0 ; ''
		std	$16,y
		ldd	<$9E
		subd	<$CE
		anda	#$1F
		std	$18,y
		ldd	<$9C
		subd	<$CC
		ora	#$E0 ; ''
		std	$1A,y
		ldd	<$7E
		subd	<$9E
		anda	#$1F
		std	$1C,y
		ldd	<$7C
		subd	<$9C
		ora	#$E0 ; ''
		std	$1E,y
		ldd	<$AE
		subd	<$7E
		anda	#$1F
		std	$20,y
		ldd	<$AC
		subd	<$7C
		ora	#$E0 ; ''
		std	$22,y
		ldd	<$DE
		subd	<$AE
		anda	#$1F
		std	$24,y
		ldd	<$DC		; Selected object model
		subd	<$AC
		ora	#$E0 ; ''
		std	$26,y
		ldd	<$1E
		subd	<$DE
		anda	#$1F
		std	$28,y
		ldd	<$1C
		subd	<$DC		; Selected object model
		ora	#$E0 ; ''
		std	$2A,y
		ldd	<$2E
		subd	<$1E
		anda	#$1F
		std	$2C,y
		ldd	<$2C
		subd	<$1C
		ora	#$E0 ; ''
		std	$2E,y
		ldd	<$EE
		subd	<$2E
		anda	#$1F
		std	$30,y
		ldd	<$EC
		subd	<$2C
		ora	#$E0 ; ''
		std	$32,y
		ldd	<$BE
		subd	<$EE
		anda	#$1F
		std	$34,y
		ldd	<$BC
		subd	<$EC
		ora	#$E0 ; ''
		std	$36,y
		ldd	<$8E
		subd	<$BE
		anda	#$1F
		std	$38,y
		ldd	<$8C
		subd	<$BC
		ora	#$E0 ; ''
		std	$3A,y
		ldd	<$7E
		subd	<$8E
		anda	#$1F
		std	$3C,y
		ldd	<$7C
		subd	<$8C
		ora	#$E0 ; ''
		std	$3E,y
		ldd	#$7200
		std	$40,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$42,y
		leay	$44,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_6EB1

; ---------------------------------------------------------------------------
byte_6FD8:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_6FD9:
		lda	#$5E ; '^'      ; Draws trench turrets
		tfr	a, dp
		ldd	<$4E
		addd	#$FF98
		anda	#$1F
		std	,y
		ldd	<$4C
		anda	#$1F
		std	2,y
		ldd	#$6480
		std	4,y
		ldd	<$3E
		subd	<$4E
		anda	#$1F
		std	6,y
		ldd	<$3C
		subd	<$4C
		ora	#$E0 ; ''
		std	8,y
		ldd	<$2E
		subd	<$3E
		anda	#$1F
		std	$A,y
		ldd	<$2C
		subd	<$3C
		ora	#$E0 ; ''
		std	$C,y
		ldd	<$1E
		subd	<$2E
		anda	#$1F
		std	$E,y
		ldd	<$1C
		subd	<$2C
		ora	#$E0 ; ''
		std	$10,y
		ldd	<$4E
		subd	<$1E
		anda	#$1F
		std	$12,y
		ldd	<$4C
		subd	<$1C
		ora	#$E0 ; ''
		std	$14,y
		ldd	<$9E
		subd	<$4E
		anda	#$1F
		std	$16,y
		ldd	<$9C
		subd	<$4C
		ora	#$E0 ; ''
		std	$18,y
		ldd	<$AE
		subd	<$9E
		anda	#$1F
		std	$1A,y
		ldd	<$AC
		subd	<$9C
		ora	#$E0 ; ''
		std	$1C,y
		ldd	<$1E
		subd	<$AE
		anda	#$1F
		std	$1E,y
		ldd	<$1C
		subd	<$AC
		ora	#$E0 ; ''
		std	$20,y
		ldd	<$AE
		subd	<$1E
		anda	#$1F
		std	$22,y
		ldd	<$AC
		subd	<$1C
		anda	#$1F
		std	$24,y
		ldd	<$6E
		subd	<$AE
		anda	#$1F
		std	$26,y
		ldd	<$6C
		subd	<$AC
		ora	#$E0 ; ''
		std	$28,y
		ldd	<$2E
		subd	<$6E
		anda	#$1F
		std	$2A,y
		ldd	<$2C
		subd	<$6C
		ora	#$E0 ; ''
		std	$2C,y
		ldd	<$3E
		subd	<$2E
		anda	#$1F
		std	$2E,y
		ldd	<$3C
		subd	<$2C
		anda	#$1F
		std	$30,y
		ldd	<$7E
		subd	<$3E
		anda	#$1F
		std	$32,y
		ldd	<$7C
		subd	<$3C
		ora	#$E0 ; ''
		std	$34,y
		ldd	<$6E
		subd	<$7E
		anda	#$1F
		std	$36,y
		ldd	<$6C
		subd	<$7C
		ora	#$E0 ; ''
		std	$38,y
		ldd	<$5E
		subd	<$6E
		anda	#$1F
		std	$3A,y
		ldd	<$5C
		subd	<$6C
		ora	#$E0 ; ''
		std	$3C,y
		ldd	<$8E
		subd	<$5E
		anda	#$1F
		std	$3E,y
		ldd	<$8C
		subd	<$5C
		ora	#$E0 ; ''
		std	$40,y
		ldd	<$7E
		subd	<$8E
		anda	#$1F
		std	$42,y
		ldd	<$7C
		subd	<$8C
		ora	#$E0 ; ''
		std	$44,y
		ldd	<$9E
		subd	<$7E
		anda	#$1F
		std	$46,y
		ldd	<$9C
		subd	<$7C
		ora	#$E0 ; ''
		std	$48,y
		ldd	<$8E
		subd	<$9E
		anda	#$1F
		std	$4A,y
		ldd	<$8C
		subd	<$9C
		ora	#$E0 ; ''
		std	$4C,y
		ldd	<$DE
		subd	<$8E
		anda	#$1F
		std	$4E,y
		ldd	<$DC		; Selected object model
		subd	<$8C
		ora	#$E0 ; ''
		std	$50,y
		ldd	<$EE
		subd	<$DE
		anda	#$1F
		std	$52,y
		ldd	<$EC
		subd	<$DC		; Selected object model
		ora	#$E0 ; ''
		std	$54,y
		ldd	<$9E
		subd	<$EE
		anda	#$1F
		std	$56,y
		ldd	<$9C
		subd	<$EC
		ora	#$E0 ; ''
		std	$58,y
		ldd	<$EE
		subd	<$9E
		anda	#$1F
		std	$5A,y
		ldd	<$EC
		subd	<$9C
		anda	#$1F
		std	$5C,y
		ldd	<$CE
		subd	<$EE
		anda	#$1F
		std	$5E,y
		ldd	<$CC
		subd	<$EC
		ora	#$E0 ; ''
		std	$60,y
		ldd	<$AE
		subd	<$CE
		anda	#$1F
		std	$62,y
		ldd	<$AC
		subd	<$CC
		ora	#$E0 ; ''
		std	$64,y
		ldd	<$5E
		subd	<$AE
		anda	#$1F
		std	$66,y
		ldd	<$5C
		subd	<$AC
		ora	#$E0 ; ''
		std	$68,y
		ldd	<$BE
		subd	<$5E
		anda	#$1F
		std	$6A,y
		ldd	<$BC
		subd	<$5C
		ora	#$E0 ; ''
		std	$6C,y
		ldd	<$CE
		subd	<$BE
		anda	#$1F
		std	$6E,y
		ldd	<$CC
		subd	<$BC
		ora	#$E0 ; ''
		std	$70,y
		ldd	<$BE
		subd	<$CE
		anda	#$1F
		std	$72,y
		ldd	<$BC
		subd	<$CC
		anda	#$1F
		std	$74,y
		ldd	<$DE
		subd	<$BE
		anda	#$1F
		std	$76,y
		ldd	<$DC		; Selected object model
		subd	<$BC
		ora	#$E0 ; ''
		std	$78,y
		ldd	#$7200
		std	$7A,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$7C,y
		leay	$7E,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_6FD9

; ---------------------------------------------------------------------------
byte_720A:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_720B:
		lda	#$5E ; '^'      ; Draws trench green squares
		tfr	a, dp
		ldd	<$0E
		addd	#$FF98		; Y axis offset	for squares
		anda	#$1F
		std	,y
		ldd	<$0C
		anda	#$1F
		std	2,y
		ldd	#$6280		; Insert Vector	STAT 2,80 instruction (Green)
		std	4,y
		ldd	<$1E
		subd	<$0E
		anda	#$1F
		std	6,y
		ldd	<$1C
		subd	<$0C
		ora	#$E0 ; ''
		std	8,y
		ldd	<$2E
		subd	<$1E
		anda	#$1F
		std	$A,y
		ldd	<$2C
		subd	<$1C
		ora	#$E0 ; ''
		std	$C,y
		ldd	<$3E
		subd	<$2E
		anda	#$1F
		std	$E,y
		ldd	<$3C
		subd	<$2C
		ora	#$E0 ; ''
		std	$10,y
		ldd	<$0E
		subd	<$3E
		anda	#$1F
		std	$12,y
		ldd	<$0C
		subd	<$3C
		ora	#$E0 ; ''
		std	$14,y
		ldd	<$4E
		subd	<$0E
		anda	#$1F
		std	$16,y
		ldd	<$4C
		subd	<$0C
		anda	#$1F
		std	$18,y
		ldd	<$5E
		subd	<$4E
		anda	#$1F
		std	$1A,y
		ldd	<$5C
		subd	<$4C
		ora	#$E0 ; ''
		std	$1C,y
		ldd	<$6E
		subd	<$5E
		anda	#$1F
		std	$1E,y
		ldd	<$6C
		subd	<$5C
		ora	#$E0 ; ''
		std	$20,y
		ldd	<$7E
		subd	<$6E
		anda	#$1F
		std	$22,y
		ldd	<$7C
		subd	<$6C
		ora	#$E0 ; ''
		std	$24,y
		ldd	<$4E
		subd	<$7E
		anda	#$1F
		std	$26,y
		ldd	<$4C
		subd	<$7C
		ora	#$E0 ; ''
		std	$28,y
		ldd	#$7200
		std	$2A,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$2C,y
		leay	$2E,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_720B

; ---------------------------------------------------------------------------
byte_72D4:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_72D5:
		lda	#$5E ; '^'      ; Draws trench catwalks
		tfr	a, dp
		ldd	<$1E
		addd	#$FF98
		anda	#$1F
		std	,y
		ldd	<$1C
		anda	#$1F
		std	2,y
		ldd	<$0E
		subd	<$1E
		anda	#$1F
		std	4,y
		ldd	<$0C
		subd	<$1C
		ora	#$E0 ; ''
		std	6,y
		ldd	<$2E
		subd	<$0E
		anda	#$1F
		std	8,y
		ldd	<$2C
		subd	<$0C
		ora	#$E0 ; ''
		std	$A,y
		ldd	<$3E
		subd	<$2E
		anda	#$1F
		std	$C,y
		ldd	<$3C
		subd	<$2C
		ora	#$E0 ; ''
		std	$E,y
		ldd	<$1E
		subd	<$3E
		anda	#$1F
		std	$10,y
		ldd	<$1C
		subd	<$3C
		ora	#$E0 ; ''
		std	$12,y
		ldd	<$5E
		subd	<$1E
		anda	#$1F
		std	$14,y
		ldd	<$5C
		subd	<$1C
		ora	#$E0 ; ''
		std	$16,y
		ldd	<$4E
		subd	<$5E
		anda	#$1F
		std	$18,y
		ldd	<$4C
		subd	<$5C
		ora	#$E0 ; ''
		std	$1A,y
		ldd	<$0E
		subd	<$4E
		anda	#$1F
		std	$1C,y
		ldd	<$0C
		subd	<$4C
		ora	#$E0 ; ''
		std	$1E,y
		ldd	#$7200
		std	$20,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$22,y
		leay	$24,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_72D5

; ---------------------------------------------------------------------------
byte_7374:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_7375:
		lda	#$5E ; '^'      ; Tower top explode: Copy math points to vector RAM?
		tfr	a, dp
		ldd	<$1E
		addd	#$FF98
		anda	#$1F
		std	,y
		ldd	<$1C
		anda	#$1F
		std	2,y
		ldd	#$A018		; Insert Vector	JSRL 0018 instruction (STAT for	colour fade?)
		std	4,y
		ldd	<$0E
		subd	<$1E
		anda	#$1F
		std	6,y
		ldd	<$0C
		subd	<$1C
		ora	#$E0 ; ''
		std	8,y
		ldd	<$2E
		subd	<$0E
		anda	#$1F
		std	$A,y
		ldd	<$2C
		subd	<$0C
		ora	#$E0 ; ''
		std	$C,y
		ldd	<$3E
		subd	<$2E
		anda	#$1F
		std	$E,y
		ldd	<$3C
		subd	<$2C
		ora	#$E0 ; ''
		std	$10,y
		ldd	<$1E
		subd	<$3E
		anda	#$1F
		std	$12,y
		ldd	<$1C
		subd	<$3C
		ora	#$E0 ; ''
		std	$14,y
		ldd	<$5E
		subd	<$1E
		anda	#$1F
		std	$16,y
		ldd	<$5C
		subd	<$1C
		ora	#$E0 ; ''
		std	$18,y
		ldd	<$6E
		subd	<$5E
		anda	#$1F
		std	$1A,y
		ldd	<$6C
		subd	<$5C
		ora	#$E0 ; ''
		std	$1C,y
		ldd	<$3E
		subd	<$6E
		anda	#$1F
		std	$1E,y
		ldd	<$3C
		subd	<$6C
		ora	#$E0 ; ''
		std	$20,y
		ldd	<$5E
		subd	<$3E
		anda	#$1F
		std	$22,y
		ldd	<$5C
		subd	<$3C
		anda	#$1F
		std	$24,y
		ldd	<$4E
		subd	<$5E
		anda	#$1F
		std	$26,y
		ldd	<$4C
		subd	<$5C
		ora	#$E0 ; ''
		std	$28,y
		ldd	<$0E
		subd	<$4E
		anda	#$1F
		std	$2A,y
		ldd	<$0C
		subd	<$4C
		ora	#$E0 ; ''
		std	$2C,y
		ldd	#$7200
		std	$2E,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$30,y
		leay	$32,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_7375

; ---------------------------------------------------------------------------
byte_7450:	fcb 1

; =============== S U B	R O U T	I N E =======================================


sub_7451:
		lda	#$5E ; '^'      ; Draws trench exhaust port
		tfr	a, dp
		ldd	<$5E
		addd	#$FF98
		anda	#$1F
		std	,y
		ldd	<$5C
		anda	#$1F
		std	2,y
		ldd	#$6280		; Insert Vector	STAT 2,80 instruction (Green)
		std	4,y
		ldd	<$9E
		subd	<$5E
		anda	#$1F
		std	6,y
		ldd	<$9C
		subd	<$5C
		ora	#$E0 ; ''
		std	8,y
		ldd	<$8E
		subd	<$9E
		anda	#$1F
		std	$A,y
		ldd	<$8C
		subd	<$9C
		ora	#$E0 ; ''
		std	$C,y
		ldd	<$4E
		subd	<$8E
		anda	#$1F
		std	$E,y
		ldd	<$4C
		subd	<$8C
		ora	#$E0 ; ''
		std	$10,y
		ldd	<$6E
		subd	<$4E
		anda	#$1F
		std	$12,y
		ldd	<$6C
		subd	<$4C
		anda	#$1F
		std	$14,y
		ldd	<$AE
		subd	<$6E
		anda	#$1F
		std	$16,y
		ldd	<$AC
		subd	<$6C
		ora	#$E0 ; ''
		std	$18,y
		ldd	<$BE
		subd	<$AE
		anda	#$1F
		std	$1A,y
		ldd	<$BC
		subd	<$AC
		ora	#$E0 ; ''
		std	$1C,y
		ldd	<$7E
		subd	<$BE
		anda	#$1F
		std	$1E,y
		ldd	<$7C
		subd	<$BC
		ora	#$E0 ; ''
		std	$20,y
		ldd	#$6380		; Insert Vector	STAT 3,80 instruction (Red)
		std	$22,y
		ldd	<$6E
		subd	<$7E
		anda	#$1F
		std	$24,y
		ldd	<$6C
		subd	<$7C
		ora	#$E0 ; ''
		std	$26,y
		ldd	<$2E
		subd	<$6E
		anda	#$1F
		std	$28,y
		ldd	<$2C
		subd	<$6C
		ora	#$E0 ; ''
		std	$2A,y
		ldd	<$6E
		subd	<$2E
		anda	#$1F
		std	$2C,y
		ldd	<$6C
		subd	<$2C
		anda	#$1F
		std	$2E,y
		ldd	<$4E
		subd	<$6E
		anda	#$1F
		std	$30,y
		ldd	<$4C
		subd	<$6C
		ora	#$E0 ; ''
		std	$32,y
		ldd	<$0E
		subd	<$4E
		anda	#$1F
		std	$34,y
		ldd	<$0C
		subd	<$4C
		ora	#$E0 ; ''
		std	$36,y
		ldd	<$4E
		subd	<$0E
		anda	#$1F
		std	$38,y
		ldd	<$4C
		subd	<$0C
		anda	#$1F
		std	$3A,y
		ldd	<$5E
		subd	<$4E
		anda	#$1F
		std	$3C,y
		ldd	<$5C
		subd	<$4C
		ora	#$E0 ; ''
		std	$3E,y
		ldd	<$1E
		subd	<$5E
		anda	#$1F
		std	$40,y
		ldd	<$1C
		subd	<$5C
		ora	#$E0 ; ''
		std	$42,y
		ldd	<$5E
		subd	<$1E
		anda	#$1F
		std	$44,y
		ldd	<$5C
		subd	<$1C
		anda	#$1F
		std	$46,y
		ldd	<$7E
		subd	<$5E
		anda	#$1F
		std	$48,y
		ldd	<$7C
		subd	<$5C
		ora	#$E0 ; ''
		std	$4A,y
		ldd	<$3E
		subd	<$7E
		anda	#$1F
		std	$4C,y
		ldd	<$3C
		subd	<$7C
		ora	#$E0 ; ''
		std	$4E,y
		ldd	#$64FF		; Insert Vector	STAT 4,FF instruction ()
		std	$50,y
		ldd	<$2E
		subd	<$3E
		anda	#$1F
		std	$52,y
		ldd	<$2C
		subd	<$3C
		ora	#$E0 ; ''
		std	$54,y
		ldd	<$0E
		subd	<$2E
		anda	#$1F
		std	$56,y
		ldd	<$0C
		subd	<$2C
		ora	#$E0 ; ''
		std	$58,y
		ldd	<$1E
		subd	<$0E
		anda	#$1F
		std	$5A,y
		ldd	<$1C
		subd	<$0C
		ora	#$E0 ; ''
		std	$5C,y
		ldd	<$3E
		subd	<$1E
		anda	#$1F
		std	$5E,y
		ldd	<$3C
		subd	<$1C
		ora	#$E0 ; ''
		std	$60,y
		ldd	#$7200		; Insert Vector	SCAL 2,00 instruction
		std	$62,y
		ldd	#$8040		; Insert Vector	CNTR instruction
		std	$64,y
		leay	$66,y
		lda	#$48 ; 'H'
		tfr	a, dp
		rts
; End of function sub_7451

; ---------------------------------------------------------------------------
JumpTable7610Hi:fdb byte_6AB1
		fdb byte_6B1A
		fdb byte_6B1A
		fdb byte_6B41
		fdb byte_6B7A
		fdb byte_6BDD
		fdb byte_6BDF
		fdb byte_6CFB
		fdb byte_6CFB
		fdb byte_6C1B
		fdb byte_6EB0
		fdb byte_720A
		fdb byte_6FD8
		fdb byte_6FD8
		fdb byte_72D4
		fdb byte_7374
		fdb byte_7450
		fdb byte_6BE1
		fdb byte_6BEF
		fdb byte_6BE1
		fdb byte_6BE1
		fdb byte_6BE1
		fdb byte_6BE1
		fdb byte_6BE1
		fdb byte_6C01
		fdb byte_6C11
Object_Size_Table:fcb $36, $14,	$14, $1E, $3A, 2, 2, $10 ; 1st object 54 points
		fcb $10, $10, $10, 8, $10, $10,	6, 6
		fcb $C,	8, $A, 8, 8, 8,	8, 8
		fcb 8, 6
Obj_List:	fdb Obj_Tie_Fighter	; 1st object XYZ data address
		fdb Obj_Tie_Wing_Frag_1
		fdb Obj_Tie_Wing_Frag_2
		fdb Obj_Tie_Wing_Frag_3
		fdb Obj_Darth_Tie
		fdb Object_6
		fdb Object_7
		fdb Object_8
		fdb Object_8
		fdb Object_8
		fdb Object_8
		fdb Obj_Trench_Squares
		fdb Object_10
		fdb Object_10
		fdb Object_11
		fdb Object_11
		fdb Object_12
		fdb Object_13
		fdb Object_14
		fdb Object_15
		fdb Object_16
		fdb Object_17
		fdb Object_18
		fdb Object_19
		fdb Object_20
		fdb Object_21
		fcb $DE, $EF, $7F, $CD,	$CF, $4F, $7D, $7D
		fcb $FE, $55, $5D, $ED,	$F1, $72, $A4, $F7
		fcb $FB, $7F, $AF, $EF,	$FD, $7E, $D3, $F7
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
aCopyright198_0:fcc ""
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF, $FF, $FF
		fcb $FF, $FF, $FF, $FF,	$FF, $FF
aCopyright1983Atari:fcc	"COPYRIGHT 1983 ATARI"

; =============== S U B	R O U T	I N E =======================================


sub_7D9A:
		ldd	<Stars_XT	; Get X	'forward' transform position
		std	Math_XT2	; XT2
		ldd	Stars_YT	; Get Y	'horizontal' transform
		std	Math_YT2	; YT2
		ldd	Stars_ZT	; Get Z	'vertical' transform
		std	Math_ZT2	; ZT2
		ldx	#Scratch_RAM_start
		ldd	#0

loc_7DB1:
		std	,x++
		cmpx	#Scratch_RAM_end ; Clear star dots RAM
		bcs	loc_7DB1
		sta	<DPbyte_88	; Clear	DPbyte_88
		lda	#$67 ; 'g'      ; Insert Vector STAT 7 for white stars
		ldb	<DPbyte_83	; Star intensity
		std	,y++		; Y points to vector RAM
		ldd	#$18C		; Point	BIC to Math RAM	$5C60
		std	MW1
		stb	<DPbyte_82	; Store	$8C to DPbyte_82
		negb			; Negate to $74
		addb	#$BE ; ''      ; Add $BE to get $32
		stb	<DPbyte_81	; Store	$32 in DPbyte_81 (why not just load B with $32 ?)
		ldu	#Scratch_RAM_end
		ldx	#Star_Dots_MRAM

loc_7DD3:				; DPbyte_84 holds running star MRAM pointer
		stx	<DPbyte_84
		lda	#$67 ; 'g'
		jsr	Math_Run_Start
		ldd	MReg00		; Math result X
		cmpd	#$100
		lble	loc_7E5D
		cmpd	#$FFF
		lbhi	loc_7E5D	; Check	perspective division value?
		std	DVSRH		; Start	division
		ldd	MReg39		; Reg39	= Reg01	x Reg01
		subd	MReg38		; Reg38	= Reg00	x Reg00
		lbcc	loc_7E5D
		ldd	MReg3A		; Reg3A	= Reg02	x Reg02
		subd	MReg38

loc_7E00:
		lbcc	loc_7E5D
		ldd	MW0		; Get division result
		std	MReg00		; Math result X
		lda	#$86 ; ''      ; Reg01 = Reg01 x Reg00
					; Reg02	= Reg02	x Reg00
		jsr	Math_Run_Start
		clrb
		lda	MReg02		; Math result Z
		lsra
		rolb
		lsra
		rolb
		lda	MReg01		; Math result Y
		lsra
		rolb
		lsra
		rolb
		lda	#8
		mul
		ldx	#Scratch_RAM_start
		abx
		ldd	2,x
		bne	loc_7E2D
		stu	2,x
		bra	loc_7E2F
; ---------------------------------------------------------------------------

loc_7E2D:
		stu	[,x]

loc_7E2F:
		stu	,x
		ldd	#0
		std	,u
		ldd	MReg02		; Math result Z
		subd	6,x
		anda	#$1F
		std	4,u
		ldd	MReg01		; Math result Y
		subd	4,x
		anda	#$1F
		cmpu	2,x
		beq	loc_7E4D	; These	3 lines	surely do nothing as ORA #0 does nothing ?
		ora	#0

loc_7E4D:
		std	2,u
		ldd	MReg02		; Math result Z
		std	6,x
		ldd	MReg01		; Math result Y
		std	4,x
		leau	6,u
		bra	loc_7E62
; ---------------------------------------------------------------------------

loc_7E5D:
		ldx	<DPbyte_84
		jsr	sub_7F9A

loc_7E62:
		inc	<DPbyte_82
		ldx	<DPbyte_84
		leax	8,x
		dec	<DPbyte_81
		lbne	loc_7DD3
		ldx	#Scratch_RAM_start

loc_7E71:
		ldu	2,x
		beq	loc_7E95
		ldd	#$1F98		; Starfield Y offset
		std	,y++
		ldd	#0
		std	,y++

loc_7E7F:
		ldd	4,u
		std	,y++
		ldd	2,u
		std	,y++
		ldd	word_33DC	; JSRL to Vector ROM subroutine	to draw	dot
		std	,y++
		ldu	,u
		bne	loc_7E7F
		ldd	#$8040		; Insert Vector	CNTR
		std	,y++

loc_7E95:
		leax	8,x
		cmpx	#Scratch_RAM_end
		bcs	loc_7E71
		ldd	MReg4C
		std	Math_XT2	; XT2
		ldd	MReg4D
		std	Math_YT2	; YT2
		ldd	MReg4E
		std	Math_ZT2	; ZT2
		rts
; End of function sub_7D9A


; =============== S U B	R O U T	I N E =======================================


sub_7EAF:
		ldx	#Scratch_RAM_start ; Towers surface dots
		ldd	#0

loc_7EB5:
		std	,x++
		cmpx	#Scratch_RAM_end
		bcs	loc_7EB5
		sta	<DPbyte_88
		ldd	#$6280		; Insert Vector	STAT 2,	80 for green dots
		std	,y++
		ldd	#$18C		; Point	BIC to Math RAM	$5C60
		std	MW1
		stb	<DPbyte_82
		negb
		addb	#$BE ; ''
		stb	<DPbyte_81
		ldu	#Scratch_RAM_end
		ldx	#Star_Dots_MRAM

loc_7ED6:
		stx	<DPbyte_84
		lda	#$67 ; 'g'
		jsr	Math_Run_Start
		ldd	MReg00		; Math result X
		cmpd	#$100
		lble	loc_7F58
		std	DVSRH
		ldd	MReg39
		subd	MReg38
		lbcc	loc_7F58
		ldd	MReg3A
		subd	MReg38
		lbcc	loc_7F58

loc_7EFF:
		ldd	MW0
		std	MReg00		; Math result X
		lda	#$86 ; ''      ; Reg01 = Reg01 x Reg00
					; Reg02	= Reg02	x Reg00
		jsr	Math_Run_Start
		clrb
		lda	MReg02		; Math result Z
		lsra
		rolb
		lsra
		rolb
		lda	MReg01		; Math result Y
		lsra
		rolb
		lsra
		rolb
		lda	#8
		mul
		ldx	#Scratch_RAM_start
		abx
		ldd	2,x
		bne	loc_7F28
		stu	2,x
		bra	loc_7F2A
; ---------------------------------------------------------------------------

loc_7F28:
		stu	[,x]

loc_7F2A:
		stu	,x
		ldd	#0
		std	,u
		ldd	MReg02		; Math result Z
		subd	6,x
		anda	#$1F
		std	4,u
		ldd	MReg01		; Math result Y
		subd	4,x
		anda	#$1F
		cmpu	2,x
		beq	loc_7F48
		ora	#0

loc_7F48:
		std	2,u
		ldd	MReg02		; Math result Z
		std	6,x
		ldd	MReg01		; Math result Y
		std	4,x
		leau	6,u
		bra	loc_7F5D
; ---------------------------------------------------------------------------

loc_7F58:				; Towers surface dots
		ldx	<DPbyte_84
		jsr	sub_7FDB

loc_7F5D:
		inc	<DPbyte_82
		ldx	<DPbyte_84
		leax	8,x
		dec	<DPbyte_81
		lbne	loc_7ED6
		ldx	#Scratch_RAM_start

loc_7F6C:
		ldu	2,x
		beq	loc_7F92
		ldd	#$FF98
		anda	#$1F
		std	,y++
		ldd	#0
		std	,y++

loc_7F7C:
		ldd	4,u
		std	,y++
		ldd	2,u
		std	,y++
		ldd	word_33DC	; JSRL to Vector ROM subroutine	to draw	dot
		std	,y++
		ldu	,u
		bne	loc_7F7C
		ldd	#$8040		; Insert Vector	CNTR
		std	,y++

loc_7F92:
		leax	8,x
		cmpx	#Scratch_RAM_end
		bcs	loc_7F6C
		rts
; End of function sub_7EAF


; =============== S U B	R O U T	I N E =======================================


sub_7F9A:
		jsr	Gen_Random
		lda	<DPbyte_53
		anda	#$1F
		ldb	<DPbyte_54
		std	,x
		mul
		tst	MReg01		; Math result Y
		bmi	loc_7FAC
		nega

loc_7FAC:
		std	2,x
		lda	<DPbyte_53
		anda	#$1F
		ldb	<DPbyte_55
		mul
		tst	MReg02		; Math result Z
		bmi	loc_7FBB
		nega

loc_7FBB:
		std	4,x
		lda	<DPbyte_82
		sta	MW2
		lda	#$60 ; '`'
		jsr	Math_Run_Start
		ldd	MReg00		; Math result X
		std	,x
		ldd	MReg01		; Math result Y
		std	2,x
		ldd	MReg02		; Math result Z
		anda	#$FF		; These	2 lines	do nothing ?
		andb	#$FF
		std	4,x
		rts
; End of function sub_7F9A


; =============== S U B	R O U T	I N E =======================================


sub_7FDB:
		jsr	$CE45		; Random number	update
		lda	<DPbyte_53
		anda	#$7F ; ''
		ora	#$70 ; 'p'
		ldb	<DPbyte_54
		addd	Math_XT2	; XT2
		std	,x
		lda	<DPbyte_55
		anda	#$7F ; ''
		tst	MReg01		; Math result Y
		bmi	loc_7FF5
		nega

loc_7FF5:				; YT2
		addd	Math_YT2
		std	2,x
		ldd	#0
		std	4,x
		rts
; End of function sub_7FDB

; end of 'ROM'


		end
